'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _sinon = require('sinon');

var _sinon2 = _interopRequireDefault(_sinon);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _authentication = require('../authentication');

var _authentication2 = _interopRequireDefault(_authentication);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var App = function (_React$Component) {
  _inherits(App, _React$Component);

  function App() {
    _classCallCheck(this, App);

    return _possibleConstructorReturn(this, (App.__proto__ || Object.getPrototypeOf(App)).apply(this, arguments));
  }

  _createClass(App, [{
    key: 'componentWillMount',
    value: function componentWillMount() {}
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {}
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps() {}
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        null,
        'App'
      );
    }
  }]);

  return App;
}(_react2.default.Component);

var AppWithAuth = (0, _authentication2.default)(App);

describe('Authentication', function () {
  beforeEach(function () {
    _sinon2.default.restore();
  });

  describe('with authentication flow', function () {
    it('should be ok', function () {
      var goToLogin = _sinon2.default.spy();
      var cwm = _sinon2.default.spy(App.prototype, 'componentWillMount');
      var cdm = _sinon2.default.spy(App.prototype, 'componentDidMount');
      var cwr = _sinon2.default.spy(App.prototype, 'componentWillReceiveProps');
      var render = _sinon2.default.spy(App.prototype, 'render');
      var authenticate = _sinon2.default.spy(AppWithAuth.prototype, 'authenticate');

      // from unauthenticated status
      var wrapper = (0, _enzyme.mount)(_react2.default.createElement(AppWithAuth, { isAuthenticated: false, goToLogin: goToLogin }));

      expect(cwm.callCount).to.be.equal(0);
      expect(cdm.callCount).to.be.equal(0);
      expect(cwr.callCount).to.be.equal(0);
      expect(render.callCount).to.be.equal(0);
      expect(authenticate.callCount).to.be.equal(1);

      expect(goToLogin.callCount).to.be.equal(1);

      //  to authenticated status
      wrapper.setProps({ isAuthenticated: true });

      expect(cwm.callCount).to.be.equal(1);
      expect(cdm.callCount).to.be.equal(1);
      expect(cwr.callCount).to.be.equal(0);
      expect(render.callCount).to.be.equal(1);
      expect(authenticate.callCount).to.be.equal(2);

      //  keeping called once
      expect(goToLogin.callCount).to.be.equal(1);

      // set others props
      wrapper.setProps({ user: {} });
      expect(cwm.callCount).to.be.equal(1);
      expect(cdm.callCount).to.be.equal(1);
      expect(cwr.callCount).to.be.equal(1);

      // will re-render
      expect(render.callCount).to.be.equal(2);

      // should call authenticate to check
      expect(authenticate.callCount).to.be.equal(3);

      // and back to unauthenticated status
      wrapper.setProps({ isAuthenticated: false });

      expect(cwm.callCount).to.be.equal(1);
      expect(cdm.callCount).to.be.equal(1);
      expect(cwr.callCount).to.be.equal(1);
      expect(render.callCount).to.be.equal(2);

      // should call authenticate
      expect(authenticate.callCount).to.be.equal(4);

      // should go to login again
      expect(goToLogin.callCount).to.be.equal(2);
    });
  });
});